#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>

#include "asim/provides/connected_application.h"
#include "asim/provides/stats_device.h"


using namespace std;

// constructor
CONNECTED_APPLICATION_CLASS::CONNECTED_APPLICATION_CLASS(VIRTUAL_PLATFORM vp) :
  clientStub(new PROCESSORSYSTEMRRR_CLIENT_STUB_CLASS(this))
{
  
}

// destructor
CONNECTED_APPLICATION_CLASS::~CONNECTED_APPLICATION_CLASS()
{
}

// init
void
CONNECTED_APPLICATION_CLASS::Init()
{

  // enable stats 
  STATS_DEVICE_SERVER_CLASS::GetInstance()->SetupStats();

}


// main
void
CONNECTED_APPLICATION_CLASS::Main()
{
  int sleepCount = 0;
  int result = 0;

  fflush(stdout); 

  while ((result = clientStub->ReadCPUToHost(0)) != 1) {
    sleep(1);
    //printf("System controller sleeps with result: %d\n", result);
    sleepCount++;
    if(sleepCount == 100) {
      printf("Failed to get response from hardware, bailing\n\n");
      printf("This means that either your hardware is hanging\n");
      printf("or that the software hasn't given it enough time\n");
      printf("to complete.  If you think it needs more time, then\n");
      printf("edit CONNECTED_APPLICATION_CLASS::Main() in ProcessorSystem.cpp\n");
      printf("(connected_application)\n");
      exit(0);
    }
  }
 
  if(result == 1) {
    printf("\n***PASSED***\n");
  }

  // Dump the stats file

  STATS_DEVICE_SERVER_CLASS::GetInstance()->DumpStats();
  STATS_DEVICE_SERVER_CLASS::GetInstance()->EmitFile();

  fflush(stdout); 
  exit(0);
}
